/*
 *  arm thread support
 *
 *  Copyright (c) 2013 Stacey D. Son
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _TARGET_ARCH_THREAD_H_
#define _TARGET_ARCH_THREAD_H_

/* Compare to arm/arm/vm_machdep.c cpu_set_upcall_kse() */
static inline void
thread_set_upcall(CPUARMState *regs, abi_ulong entry,
    abi_ulong arg, abi_ulong stack_base, abi_ulong stack_size)
{
    abi_ulong sp;

    sp = ((stack_base + stack_size) & (8 - 1)) -
        sizeof(struct target_trapframe);

    /* fp = sp = stack base */
    regs->regs[11] = regs->regs[13] = sp;
    /* pc = start function entry */
    regs->regs[15] = regs->regs[14] = entry & 0xfffffffe;
    /* r0 = arg */
    regs->regs[0] = arg;
}

#endif /* !_TARGET_ARCH_THREAD_H_ */
