#ifndef _TARGET_OS_STACK_H_
#define _TARGET_OS_STACK_H_

#include "target_arch_sigtramp.h"

static inline abi_ulong setup_initial_stack(abi_ulong p,
        struct bsd_binprm *bprm, abi_ulong sbase, abi_ulong size,
        abi_ulong addr)
{
    int i;
    abi_ulong stack_base;

    stack_base = addr + size - MAX_ARG_PAGES * TARGET_PAGE_SIZE;
    p += stack_base;

    for (i = 0; i < MAX_ARG_PAGES; i++) {
        if (bprm->page[i]) {
            info->rss++;
            if (!memcpy_to_target(stack_base, bprm->page[i],
                        TARGET_PAGE_SIZE)) {
                return 0;
            }
            g_free(bprm->page[i]);
        }
        stack_base += TARGET_PAGE_SIZE;
    }

    return p;
}

#endif /* !_TARGET_OS_STACK_H_ */
